; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;			(adr_GRAFIC_KREIS_RADIUS)	Radius									
;			(adr_GRAFIC_X1_L)			Mittelpunkt								
;			(adr_GRAFIC_X1_H)													
;			(adr_GRAFIC_Y1_L)													
;			(adr_GRAFIC_Y1_H)													
; 																				
;	R0+R1+R2:	Hilfsregister													
; 	temp:	Hilfsregister														
; 	temp1: 	Hilfsregister														
; 	temp2: 	Hilfsregister														
; 	temp3: 	Hilfsregister														
; 	temp4: 	Hilfsregister														
;	temp5:	TURBO																
;	temp6:	TURBO																
;	temp7:	STEP																
;	temp8:	SCHLEIFE (WINKEL)													
;	temp9:	SCHLEIFE (WINKEL)													
; 																				
GRAFIC_KREIS:
	WDR
	; RADIUS NULL ?						
	LDS temp,(adr_GRAFIC_KREIS_RADIUS)		; RADIUS						
	tst temp
	brne GRAFIC_KREIS_RUN
	LDS XL,(adr_GRAFIC_X1_L)			; X-KOORDINATEN MITTEL-PUNKT	
	LDS XH,(adr_GRAFIC_X1_H)
	LDS YL,(adr_GRAFIC_Y1_L)			; Y-KOORDINATEN MITTEL-PUNKT	
	LDS YH,(adr_GRAFIC_Y1_H)
	rcall GRAFIC_PUNKT_X_Y
	ret
;-------------------------------------------------------------------------------
GRAFIC_KREIS_RUN:
; STEP bestimmen Genauigkeit/Schnelligkeit 	
	ldi temp7,16
	LDS temp,(adr_GRAFIC_KREIS_RADIUS)	; RADIUS				
	SBRC temp,4			;>=16
	ldi temp7,8;8
	SBRC temp,5			;>=32
	ldi temp7,4;4
	SBRC temp,6			;>=64
	ldi temp7,2;2
	SBRC temp,7			;>=128
	ldi temp7,1;1			; feinste Darstellung
;	ldi temp7,1
;-------------------------------------------------------------------------------
	; Initialisierung					
	ldi temp5,255			; TURBO	
	ldi temp6,255			; TURBO	
	; SCHLEIFE fr VOLLKREIS			
	ldi temp8,LOW (3600)	; WINKEL
	ldi temp9,HIGH(3600)
;-------------------------------------------------------------------------------
GRAFIC_KREIS_SCHLEIFE:
	; SINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_SINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_SINUS*2)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; TURBO (neuer Tabellenwert=alter Tabellenwert)			
	cp temp1,temp5	; TURBO
	brne GRAFIC_KREIS_X_RUN
	rjmp GRAFIC_KREIS_X_FERTIG
GRAFIC_KREIS_X_RUN:
	mov temp5,temp1	; TURBO
	; WERT mal RADIUS							
	LDS temp3,(adr_GRAFIC_KREIS_RADIUS)		; RADIUS						
	; MULTIPLIKATION_16-BIT(signiert) mal 8-BIT(unsigniert) 
  	mul temp1,temp3
  	mov XL,R0
  	mov R2,R1
  	mulsu temp2,temp3
  	mov XH,R0
  	add XH,R2
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC XH,7	; Sprung bei positiv	
	rjmp GRAFIC_KREIS_X_n
	subi XL,LOW (-128)	; +128	
	sbci XH,HIGH(-128)
	rjmp GRAFIC_KREIS_X_DIV
GRAFIC_KREIS_X_n:
	subi XL,LOW (128)	; -128	
	sbci XH,HIGH(128)
GRAFIC_KREIS_X_DIV:
	; durch 256 (signiert)						
	mov XL,XH
	SBRS XL,7	; Sprung bei negativ	
	ldi XH,0
	SBRC XL,7	; Sprung bei positiv	
	ldi XH,255
	; OFFSET-POSITION addieren			
	LDS temp1,(adr_GRAFIC_X1_L)		; X-KOORDINATEN MITTEL-PUNKT	
	LDS temp2,(adr_GRAFIC_X1_H)
	add XL,temp1
	adc XH,temp2
GRAFIC_KREIS_X_FERTIG:
;-------------------------------------------------------------------------------
	; COSINUS-WERT aus WINKEL berechnen	
	ldi ZH, high(TABELLE_COSINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_COSINUS*2)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; TURBO (neuer Tabellenwert=alter Tabellenwert)			
	cp temp1,temp6
	brne GRAFIC_KREIS_Y_RUN
	rjmp GRAFIC_KREIS_Y_FERTIG
GRAFIC_KREIS_Y_RUN:
	mov temp6,temp1
	; WERT mal RADIUS							
	LDS temp3,(adr_GRAFIC_KREIS_RADIUS)		; RADIUS						
	; MULTIPLIKATION_16-BIT(signiert) mal 8-BIT(unsigniert) 
  	mul temp1,temp3
  	mov YL,R0
  	mov R2,R1
  	mulsu temp2,temp3
  	mov YH,R0
  	add YH,R2
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC YH,7	; Sprung bei positiv	
	rjmp GRAFIC_KREIS_Y_n
	subi YL,LOW (-128)	; +128	
	sbci YH,HIGH(-128)
	rjmp GRAFIC_KREIS_Y_DIV
GRAFIC_KREIS_Y_n:
	subi YL,LOW (128)	; -128	
	sbci YH,HIGH(128)
GRAFIC_KREIS_Y_DIV:
	; durch 256 (signiert)						
	mov YL,YH
	SBRS YL,7	; Sprung bei negativ	
	ldi YH,0
	SBRC YL,7	; Sprung bei positiv	
	ldi YH,255
	; OFFSET-POSITION addieren			
	LDS temp1,(adr_GRAFIC_Y1_L)			; Y-KOORDINATEN MITTEL-PUNKT	
	LDS temp2,(adr_GRAFIC_Y1_H)
	add YL,temp1
	adc YH,temp2
GRAFIC_KREIS_Y_FERTIG:
;-------------------------------------------------------------------------------
	; PUNKT ZEICHNEN			
	rcall GRAFIC_PUNKT_X_Y
;-------------------------------------------------------------------------------
	; SCHLEIFE fr VOLLKREIS	
	sub temp8,temp7		; STEP, Schrittweite		
	sbc temp9,NULL
	SBRS temp9,7		; SCHLEIFE negativ/fertig? 
	rjmp GRAFIC_KREIS_SCHLEIFE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
